/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1998-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
/*^M
** A collection of things thought to be obsolete^M
*/^M
^M
#if defined(PROBSLET_H)^M
#else^M
#define PROBSLET_H^M
^M
#include "prio.h"^M
^M
PR_BEGIN_EXTERN_C^M
^M
/*^M
** Yield the current thread.  The proper function to use in place of^M
** PR_Yield() is PR_Sleep() with an argument of PR_INTERVAL_NO_WAIT.^M
*/^M
NSPR_API(PRStatus) PR_Yield(void);^M
^M
/************************************************************************/^M
/************* The following definitions are for select *****************/^M
/************************************************************************/^M
^M
/*^M
** The following is obsolete and will be deleted in the next release!^M
** These are provided for compatibility, but are GUARANTEED to be slow.^M
**^M
** Override PR_MAX_SELECT_DESC if you need more space in the select set.^M
*/^M
#ifndef PR_MAX_SELECT_DESC^M
#define PR_MAX_SELECT_DESC 1024^M
#endif^M
typedef struct PR_fd_set {^M
    PRUint32      hsize;^M
    PRFileDesc   *harray[PR_MAX_SELECT_DESC];^M
    PRUint32      nsize;^M
    PRInt32       narray[PR_MAX_SELECT_DESC];^M
} PR_fd_set;^M
^M
/*^M
*************************************************************************^M
** FUNCTION:    PR_Select^M
** DESCRIPTION:^M
**^M
** The call returns as soon as I/O is ready on one or more of the underlying^M
** file/socket descriptors or an exceptional condition is pending. A count of the ^M
** number of ready descriptors is returned unless a timeout occurs in which case ^M
** zero is returned.  On return, PR_Select replaces the given descriptor sets with ^M
** subsets consisting of those descriptors that are ready for the requested condition.^M
** The total number of ready descriptors in all the sets is the return value.^M
**^M
** INPUTS:^M
**   PRInt32 num             ^M
**       This argument is unused but is provided for select(unix) interface^M
**       compatability.  All input PR_fd_set arguments are self-describing^M
**       with its own maximum number of elements in the set.^M
**                               ^M
**   PR_fd_set *readfds^M
**       A set describing the io descriptors for which ready for reading^M
**       condition is of interest.  ^M
**                               ^M
**   PR_fd_set *writefds^M
**       A set describing the io descriptors for which ready for writing^M
**       condition is of interest.  ^M
**                               ^M
**   PR_fd_set *exceptfds^M
**       A set describing the io descriptors for which exception pending^M
**       condition is of interest.  ^M
**^M
**   Any of the above readfds, writefds or exceptfds may be given as NULL ^M
**   pointers if no descriptors are of interest for that particular condition.                          ^M
**   ^M
**   PRIntervalTime timeout  ^M
**       Amount of time the call will block waiting for I/O to become ready. ^M
**       If this time expires without any I/O becoming ready, the result will^M
**       be zero.^M
**^M
** OUTPUTS:    ^M
**   PR_fd_set *readfds^M
**       A set describing the io descriptors which are ready for reading.^M
**                               ^M
**   PR_fd_set *writefds^M
**       A set describing the io descriptors which are ready for writing.^M
**                               ^M
**   PR_fd_set *exceptfds^M
**       A set describing the io descriptors which have pending exception.^M
**^M
** RETURN:PRInt32^M
**   Number of io descriptors with asked for conditions or zero if the function^M
**   timed out or -1 on failure.  The reason for the failure is obtained by ^M
**   calling PR_GetError().^M
** XXX can we implement this on windoze and mac?^M
**************************************************************************^M
*/^M
NSPR_API(PRInt32) PR_Select(^M
    PRInt32 num, PR_fd_set *readfds, PR_fd_set *writefds,^M
    PR_fd_set *exceptfds, PRIntervalTime timeout);^M
^M
/* ^M
** The following are not thread safe for two threads operating on them at the^M
** same time.^M
**^M
** The following routines are provided for manipulating io descriptor sets.^M
** PR_FD_ZERO(&fdset) initializes a descriptor set fdset to the null set.^M
** PR_FD_SET(fd, &fdset) includes a particular file descriptor fd in fdset.^M
** PR_FD_CLR(fd, &fdset) removes a file descriptor fd from fdset.  ^M
** PR_FD_ISSET(fd, &fdset) is nonzero if file descriptor fd is a member of ^M
** fdset, zero otherwise.^M
**^M
** PR_FD_NSET(osfd, &fdset) includes a particular native file descriptor osfd^M
** in fdset.^M
** PR_FD_NCLR(osfd, &fdset) removes a native file descriptor osfd from fdset.  ^M
** PR_FD_NISSET(osfd, &fdset) is nonzero if native file descriptor osfd is a member of ^M
** fdset, zero otherwise.^M
*/^M
^M
NSPR_API(void)        PR_FD_ZERO(PR_fd_set *set);^M
NSPR_API(void)        PR_FD_SET(PRFileDesc *fd, PR_fd_set *set);^M
NSPR_API(void)        PR_FD_CLR(PRFileDesc *fd, PR_fd_set *set);^M
NSPR_API(PRInt32)     PR_FD_ISSET(PRFileDesc *fd, PR_fd_set *set);^M
NSPR_API(void)        PR_FD_NSET(PRInt32 osfd, PR_fd_set *set);^M
NSPR_API(void)        PR_FD_NCLR(PRInt32 osfd, PR_fd_set *set);^M
NSPR_API(PRInt32)     PR_FD_NISSET(PRInt32 osfd, PR_fd_set *set);^M
^M
#ifndef NO_NSPR_10_SUPPORT^M
#ifdef XP_MAC^M
#include <stat.h>^M
#else^M
#include <sys/stat.h>^M
#endif^M
^M
NSPR_API(PRInt32) PR_Stat(const char *path, struct stat *buf);^M
#endif /* NO_NSPR_10_SUPPORT */^M
^M
PR_END_EXTERN_C^M
^M
#endif /* defined(PROBSLET_H) */^M
^M
/* probslet.h */^M
