/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1998-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
#ifndef _plbase64_h^M
#define _plbase64_h^M
^M
#include "prtypes.h"^M
^M
PR_BEGIN_EXTERN_C^M
^M
/*^M
 * PL_Base64Encode^M
 *^M
 * This routine encodes the data pointed to by the "src" parameter using the^M
 * base64 algorithm, and returns a pointer to the result.  If the "srclen"^M
 * parameter is not zero, it specifies the length of the source data.  If it^M
 * is zero, the source data is assumed to be null-terminated, and PL_strlen^M
 * is used to determine the source length.  If the "dest" parameter is not^M
 * null, it is assumed to point to a buffer of sufficient size (which may be^M
 * calculated: ((srclen + 2)/3)*4) into which the encoded data is placed ^M
 * (without any termination).  If the "dest" parameter is null, a buffer is^M
 * allocated from the heap to hold the encoded data, and the result *will*^M
 * be terminated with an extra null character.  It is the caller's ^M
 * responsibility to free the result when it is allocated.  A null is returned ^M
 * if the allocation fails.^M
 */^M
^M
PR_EXTERN(char *)^M
PL_Base64Encode^M
(^M
    const char *src,^M
    PRUint32    srclen,^M
    char       *dest^M
);^M
^M
/*^M
 * PL_Base64Decode^M
 *^M
 * This routine decodes the data pointed to by the "src" parameter using^M
 * the base64 algorithm, and returns a pointer to the result.  The source^M
 * may either include or exclude any trailing '=' characters.  If the^M
 * "srclen" parameter is not zero, it specifies the length of the source^M
 * data.  If it is zero, PL_strlen will be used to determine the source^M
 * length.  If the "dest" parameter is not null, it is assumed to point to^M
 * a buffer of sufficient size (which may be calculated: (srclen * 3)/4^M
 * when srclen includes the '=' characters) into which the decoded data^M
 * is placed (without any termination).  If the "dest" parameter is null,^M
 * a buffer is allocated from the heap to hold the decoded data, and the^M
 * result *will* be terminated with an extra null character.  It is the^M
 * caller's responsibility to free the result when it is allocated.  A null^M
 * is retuned if the allocation fails, or if the source is not well-coded.^M
 */^M
^M
PR_EXTERN(char *)^M
PL_Base64Decode^M
(^M
    const char *src,^M
    PRUint32    srclen,^M
    char       *dest^M
);^M
^M
PR_END_EXTERN_C^M
^M
#endif /* _plbase64_h */^M
