/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1998-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
/*^M
 * plresolv.h - asynchronous name resolution using DNS ^M
 */^M
^M
#ifndef _PLRESOLV_H_^M
#define _PLRESOLV_H_^M
^M
/*^M
** THIS IS WORK IN PROGRESS. DO NOT ATTEMPT TO USE ANY PORTION OF THIS^M
** API UNTIL THIS MESSAGE NO LONGER EXISTS. IF YOU DO, THEN YOU SURRENDER^M
** THE RIGHT TO COMPLAIN ABOUT ANY CONTENT.^M
*/^M
^M
#if defined(XP_UNIX)^M
^M
#include <prtypes.h>^M
#include <prnetdb.h>^M
^M
NSPR_BEGIN_EXTERN_C^M
^M
#define PL_RESOLVE_MAXHOSTENTBUF        1024^M
#define PL_RESOLVE_DEFAULT_TIMEOUT      0^M
^M
/* Error return codes */^M
#define PL_RESOLVE_OK            0^M
#define PL_RESOLVE_EWINIT        1           /* Failed to initialize window */^M
#define PL_RESOLVE_EMAKE         2           /* Failed to create request */^M
#define PL_RESOLVE_ELAUNCH       3           /* Error launching Async request */^M
#define PL_RESOLVE_ETIMEDOUT     4           /* Request timed-out */^M
#define PL_RESOLVE_EINVAL        5           /* Invalid argument */^M
#define PL_RESOLVE_EOVERFLOW     6           /* Buffer Overflow */^M
#define PL_RESOLVE_EUNKNOWN      7           /* berzerk error */^M
^M
/* ----------- Function Prototypes ----------------*/^M
^M
PR_EXTERN(PRStatus) PL_ResolveName(^M
    const char *name, unsigned char *buf,^M
    PRIntn bufsize, PRIntervalTime timeout,^M
    PRHostEnt *hostentry, PRIntervalTime *ttl);^M
^M
PR_EXTERN(PRStatus) PL_ResolveAddr(^M
    const PRNetAddr *address, unsigned char *buf,^M
    PRIntn bufsize, PRIntervalTime timeout,^M
    PRHostEnt *hostentry, PRIntervalTime *ttl);^M
^M
typedef struct PLResolveStats {^M
    int re_errors;^M
    int re_nu_look;^M
    int re_na_look;^M
    int re_replies;^M
    int re_requests;^M
    int re_resends;^M
    int re_sent;^M
    int re_timeouts;^M
} PLResolveStats;^M
^M
typedef struct PLResoveInfo {^M
    PRBool enabled;^M
    PRUint32 numNameLookups;^M
    PRUint32 numAddrLookups;^M
    PRUint32 numLookupsInProgress;^M
    PLResolveStats stats;^M
} PLResoveInfo;^M
^M
PR_EXTERN(void) PL_ResolveInfo(PLResoveInfo *info);^M
^M
NSPR_END_EXTERN_C^M
^M
#endif /* defined(XP_UNIX) */^M
^M
#endif /* _PLRESOLV_H_ */^M
