/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1998-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
#ifndef prcmon_h___^M
#define prcmon_h___^M
^M
/*^M
** Interface to cached monitors. Cached monitors use an address to find a^M
** given PR monitor. In this way a monitor can be associated with another^M
** object without preallocating a monitor for all objects.^M
**^M
** A hash table is used to quickly map addresses to individual monitors^M
** and the system automatically grows the hash table as needed.^M
**^M
** Cache monitors are about 5 times slower to use than uncached monitors.^M
*/^M
#include "prmon.h"^M
#include "prinrval.h"^M
^M
PR_BEGIN_EXTERN_C^M
^M
/**^M
** Like PR_EnterMonitor except use the "address" to find a monitor in the^M
** monitor cache. If successful, returns the PRMonitor now associated^M
** with "address". Note that you must PR_CExitMonitor the address to^M
** release the monitor cache entry (otherwise the monitor cache will fill^M
** up). This call will return NULL if the monitor cache needs to be^M
** expanded and the system is out of memory.^M
*/^M
NSPR_API(PRMonitor*) PR_CEnterMonitor(void *address);^M
^M
/*^M
** Like PR_ExitMonitor except use the "address" to find a monitor in the^M
** monitor cache.^M
*/^M
NSPR_API(PRStatus) PR_CExitMonitor(void *address);^M
^M
/*^M
** Like PR_Wait except use the "address" to find a monitor in the^M
** monitor cache.^M
*/^M
NSPR_API(PRStatus) PR_CWait(void *address, PRIntervalTime timeout);^M
^M
/*^M
** Like PR_Notify except use the "address" to find a monitor in the^M
** monitor cache.^M
*/^M
NSPR_API(PRStatus) PR_CNotify(void *address);^M
^M
/*^M
** Like PR_NotifyAll except use the "address" to find a monitor in the^M
** monitor cache.^M
*/^M
NSPR_API(PRStatus) PR_CNotifyAll(void *address);^M
^M
/*^M
** Set a callback to be invoked each time a monitor is recycled from the cache^M
** freelist, with the monitor's cache-key passed in address.^M
*/^M
NSPR_API(void) PR_CSetOnMonitorRecycle(void (*callback)(void *address));^M
^M
PR_END_EXTERN_C^M
^M
#endif /* prcmon_h___ */^M
