/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1998-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
/*^M
 * File:		prpdce.h^M
 * Description:	This file is the API defined to allow for DCE (aka POSIX)^M
 *				thread emulation in an NSPR environment. It is not the^M
 *				intent that this be a fully supported API.^M
 */^M
^M
#if !defined(PRPDCE_H)^M
#define PRPDCE_H^M
^M
#include "prlock.h"^M
#include "prcvar.h"^M
#include "prtypes.h"^M
#include "prinrval.h"^M
^M
PR_BEGIN_EXTERN_C^M
^M
#define _PR_NAKED_CV_LOCK (PRLock*)0xdce1dce1^M
^M
/*^M
** Test and acquire a lock.^M
**^M
** If the lock is acquired by the calling thread, the^M
** return value will be PR_SUCCESS. If the lock is^M
** already held, by another thread or this thread, the^M
** result will be PR_FAILURE.^M
*/^M
NSPR_API(PRStatus) PRP_TryLock(PRLock *lock);^M
^M
/*^M
** Create a naked condition variable^M
**^M
** A "naked" condition variable is one that is not created bound^M
** to a lock. The CV created with this function is the only type^M
** that may be used in the subsequent "naked" condition variable^M
** operations (see PRP_NakedWait, PRP_NakedNotify, PRP_NakedBroadcast);^M
*/^M
NSPR_API(PRCondVar*) PRP_NewNakedCondVar(void);^M
^M
/*^M
** Destroy a naked condition variable^M
**^M
** Destroy the condition variable created by PR_NewNakedCondVar.^M
*/^M
NSPR_API(void) PRP_DestroyNakedCondVar(PRCondVar *cvar);^M
^M
/*^M
** Wait on a condition^M
**^M
** Wait on the condition variable 'cvar'. It is asserted that^M
** the lock protecting the condition 'lock' is held by the^M
** calling thread. If more time expires than that declared in^M
** 'timeout' the condition will be notified. Waits can be^M
** interrupted by another thread.^M
**^M
** NB: The CV ('cvar') must be one created using PR_NewNakedCondVar.^M
*/^M
NSPR_API(PRStatus) PRP_NakedWait(^M
	PRCondVar *cvar, PRLock *lock, PRIntervalTime timeout);^M
^M
/*^M
** Notify a thread waiting on a condition^M
**^M
** Notify the condition specified 'cvar'.^M
**^M
** NB: The CV ('cvar') must be one created using PR_NewNakedCondVar.^M
*/^M
NSPR_API(PRStatus) PRP_NakedNotify(PRCondVar *cvar);^M
^M
/*^M
** Notify all threads waiting on a condition^M
**^M
** Notify the condition specified 'cvar'.^M
**^M
** NB: The CV ('cvar') must be one created using PR_NewNakedCondVar.^M
*/^M
NSPR_API(PRStatus) PRP_NakedBroadcast(PRCondVar *cvar);^M
^M
PR_END_EXTERN_C^M
^M
#endif /* PRPDCE_H */^M
