/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1998-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
#ifndef prsystem_h___^M
#define prsystem_h___^M
^M
/*^M
** API to NSPR functions returning system info.^M
*/^M
#include "prtypes.h"^M
^M
PR_BEGIN_EXTERN_C^M
^M
/*^M
** Get the host' directory separator.^M
**  Pathnames are then assumed to be of the form:^M
**      [<sep><root_component><sep>]*(<component><sep>)<leaf_name>^M
*/^M
^M
NSPR_API(char) PR_GetDirectorySeparator(void);^M
^M
/*^M
** OBSOLETE -- the function name is misspelled.^M
** Use PR_GetDirectorySeparator instead.^M
*/^M
^M
NSPR_API(char) PR_GetDirectorySepartor(void);^M
^M
^M
/* Types of information available via PR_GetSystemInfo(...) */^M
typedef enum {^M
    PR_SI_HOSTNAME,^M
    PR_SI_SYSNAME,^M
    PR_SI_RELEASE,^M
    PR_SI_ARCHITECTURE^M
} PRSysInfo;^M
^M
^M
/*^M
** If successful returns a null termintated string in 'buf' for^M
** the information indicated in 'cmd'. If unseccussful the reason for^M
** the failure can be retrieved from PR_GetError().^M
**^M
** The buffer is allocated by the caller and should be at least^M
** SYS_INFO_BUFFER_LENGTH bytes in length.^M
*/^M
^M
#define SYS_INFO_BUFFER_LENGTH 256^M
^M
NSPR_API(PRStatus) PR_GetSystemInfo(PRSysInfo cmd, char *buf, PRUint32 buflen);^M
^M
/*^M
** Return the number of bytes in a page^M
*/^M
NSPR_API(PRInt32) PR_GetPageSize(void);^M
^M
/*^M
** Return log2 of the size of a page^M
*/^M
NSPR_API(PRInt32) PR_GetPageShift(void);^M
^M
/*^M
** PR_GetNumberOfProcessors() -- returns the number of CPUs^M
**^M
** Description:^M
** PR_GetNumberOfProcessors() extracts the number of processors^M
** (CPUs available in an SMP system) and returns the number.^M
** ^M
** Parameters:^M
**   none^M
**^M
** Returns:^M
**   The number of available processors or -1 on error^M
** ^M
*/^M
NSPR_API(PRInt32) PR_GetNumberOfProcessors( void );^M
^M
PR_END_EXTERN_C^M
^M
#endif /* prsystem_h___ */^M
