/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1998-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
/*^M
** File:                prtypes.h^M
** Description: Definitions of NSPR's basic types^M
**^M
** Prototypes and macros used to make up for deficiencies in ANSI environments^M
** that we have found.^M
**^M
** Since we do not wrap <stdlib.h> and all the other standard headers, authors^M
** of portable code will not know in general that they need these definitions.^M
** Instead of requiring these authors to find the dependent uses in their code^M
** and take the following steps only in those C files, we take steps once here^M
** for all C files.^M
**/^M
^M
#ifndef prtypes_h___^M
#define prtypes_h___^M
^M
#ifdef MDCPUCFG^M
#include MDCPUCFG^M
#else^M
#include "prcpucfg.h"^M
#endif^M
^M
#include <stddef.h>^M
^M
/***********************************************************************^M
** MACROS:      PR_EXTERN^M
**              PR_IMPLEMENT^M
** DESCRIPTION:^M
**      These are only for externally visible routines and globals.  For^M
**      internal routines, just use "extern" for type checking and that^M
**      will not export internal cross-file or forward-declared symbols.^M
**      Define a macro for declaring procedures return types. We use this to^M
**      deal with windoze specific type hackery for DLL definitions. Use^M
**      PR_EXTERN when the prototype for the method is declared. Use^M
**      PR_IMPLEMENT for the implementation of the method.^M
**^M
** Example:^M
**   in dowhim.h^M
**     PR_EXTERN( void ) DoWhatIMean( void );^M
**   in dowhim.c^M
**     PR_IMPLEMENT( void ) DoWhatIMean( void ) { return; }^M
**^M
**^M
***********************************************************************/^M
#if defined(WIN32)^M
^M
#if defined(__GNUC__)^M
#undef _declspec^M
#define _declspec(x) __declspec(x)^M
#endif^M
^M
#define PR_EXPORT(__type) extern _declspec(dllexport) __type^M
#define PR_EXPORT_DATA(__type) extern _declspec(dllexport) __type^M
#define PR_IMPORT(__type) _declspec(dllimport) __type^M
#define PR_IMPORT_DATA(__type) _declspec(dllimport) __type^M
^M
#define PR_EXTERN(__type) extern _declspec(dllexport) __type^M
#define PR_IMPLEMENT(__type) _declspec(dllexport) __type^M
#define PR_EXTERN_DATA(__type) extern _declspec(dllexport) __type^M
#define PR_IMPLEMENT_DATA(__type) _declspec(dllexport) __type^M
^M
#define PR_CALLBACK^M
#define PR_CALLBACK_DECL^M
#define PR_STATIC_CALLBACK(__x) static __x^M
^M
#elif defined(XP_BEOS)^M
^M
#define PR_EXPORT(__type) extern __declspec(dllexport) __type^M
#define PR_EXPORT_DATA(__type) extern __declspec(dllexport) __type^M
#define PR_IMPORT(__type) extern __declspec(dllexport) __type^M
#define PR_IMPORT_DATA(__type) extern __declspec(dllexport) __type^M
^M
#define PR_EXTERN(__type) extern __declspec(dllexport) __type^M
#define PR_IMPLEMENT(__type) __declspec(dllexport) __type^M
#define PR_EXTERN_DATA(__type) extern __declspec(dllexport) __type^M
#define PR_IMPLEMENT_DATA(__type) __declspec(dllexport) __type^M
^M
#define PR_CALLBACK^M
#define PR_CALLBACK_DECL^M
#define PR_STATIC_CALLBACK(__x) static __x^M
^M
#elif defined(WIN16)^M
^M
#define PR_CALLBACK_DECL        __cdecl^M
^M
#if defined(_WINDLL)^M
#define PR_EXPORT(__type) extern __type _cdecl _export _loadds^M
#define PR_IMPORT(__type) extern __type _cdecl _export _loadds^M
#define PR_EXPORT_DATA(__type) extern __type _export^M
#define PR_IMPORT_DATA(__type) extern __type _export^M
^M
#define PR_EXTERN(__type) extern __type _cdecl _export _loadds^M
#define PR_IMPLEMENT(__type) __type _cdecl _export _loadds^M
#define PR_EXTERN_DATA(__type) extern __type _export^M
#define PR_IMPLEMENT_DATA(__type) __type _export^M
^M
#define PR_CALLBACK             __cdecl __loadds^M
#define PR_STATIC_CALLBACK(__x) static __x PR_CALLBACK^M
^M
#else /* this must be .EXE */^M
#define PR_EXPORT(__type) extern __type _cdecl _export^M
#define PR_IMPORT(__type) extern __type _cdecl _export^M
#define PR_EXPORT_DATA(__type) extern __type _export^M
#define PR_IMPORT_DATA(__type) extern __type _export^M
^M
#define PR_EXTERN(__type) extern __type _cdecl _export^M
#define PR_IMPLEMENT(__type) __type _cdecl _export^M
#define PR_EXTERN_DATA(__type) extern __type _export^M
#define PR_IMPLEMENT_DATA(__type) __type _export^M
^M
#define PR_CALLBACK             __cdecl __loadds^M
#define PR_STATIC_CALLBACK(__x) __x PR_CALLBACK^M
#endif /* _WINDLL */^M
^M
#elif defined(XP_MAC)^M
^M
#define PR_EXPORT(__type) extern __declspec(export) __type^M
#define PR_EXPORT_DATA(__type) extern __declspec(export) __type^M
#define PR_IMPORT(__type) extern __declspec(export) __type^M
#define PR_IMPORT_DATA(__type) extern __declspec(export) __type^M
^M
#define PR_EXTERN(__type) extern __declspec(export) __type^M
#define PR_IMPLEMENT(__type) __declspec(export) __type^M
#define PR_EXTERN_DATA(__type) extern __declspec(export) __type^M
#define PR_IMPLEMENT_DATA(__type) __declspec(export) __type^M
^M
#define PR_CALLBACK^M
#define PR_CALLBACK_DECL^M
#define PR_STATIC_CALLBACK(__x) static __x^M
^M
#elif defined(XP_OS2_VACPP) ^M
^M
#define PR_EXPORT(__type) extern __type^M
#define PR_EXPORT_DATA(__type) extern __type^M
#define PR_IMPORT(__type) extern __type^M
#define PR_IMPORT_DATA(__type) extern __type^M
^M
#define PR_EXTERN(__type) extern __type^M
#define PR_IMPLEMENT(__type) __type^M
#define PR_EXTERN_DATA(__type) extern __type^M
#define PR_IMPLEMENT_DATA(__type) __type^M
#define PR_CALLBACK _Optlink^M
#define PR_CALLBACK_DECL^M
#define PR_STATIC_CALLBACK(__x) static __x PR_CALLBACK^M
^M
#else /* Unix */^M
^M
#define PR_EXPORT(__type) extern __type^M
#define PR_EXPORT_DATA(__type) extern __type^M
#define PR_IMPORT(__type) extern __type^M
#define PR_IMPORT_DATA(__type) extern __type^M
^M
#define PR_EXTERN(__type) extern __type^M
#define PR_IMPLEMENT(__type) __type^M
#define PR_EXTERN_DATA(__type) extern __type^M
#define PR_IMPLEMENT_DATA(__type) __type^M
#define PR_CALLBACK^M
#define PR_CALLBACK_DECL^M
#define PR_STATIC_CALLBACK(__x) static __x^M
^M
#endif^M
^M
#if defined(_NSPR_BUILD_)^M
#define NSPR_API(__type) PR_EXPORT(__type)^M
#define NSPR_DATA_API(__type) PR_EXPORT_DATA(__type)^M
#else^M
#define NSPR_API(__type) PR_IMPORT(__type)^M
#define NSPR_DATA_API(__type) PR_IMPORT_DATA(__type)^M
#endif^M
^M
/***********************************************************************^M
** MACROS:      PR_BEGIN_MACRO^M
**              PR_END_MACRO^M
** DESCRIPTION:^M
**      Macro body brackets so that macros with compound statement definitions^M
**      behave syntactically more like functions when called.^M
***********************************************************************/^M
#define PR_BEGIN_MACRO  do {^M
#define PR_END_MACRO    } while (0)^M
^M
/***********************************************************************^M
** MACROS:      PR_BEGIN_EXTERN_C^M
**              PR_END_EXTERN_C^M
** DESCRIPTION:^M
**      Macro shorthands for conditional C++ extern block delimiters.^M
***********************************************************************/^M
#ifdef __cplusplus^M
#define PR_BEGIN_EXTERN_C       extern "C" {^M
#define PR_END_EXTERN_C         }^M
#else^M
#define PR_BEGIN_EXTERN_C^M
#define PR_END_EXTERN_C^M
#endif^M
^M
/***********************************************************************^M
** MACROS:      PR_BIT^M
**              PR_BITMASK^M
** DESCRIPTION:^M
** Bit masking macros.  XXX n must be <= 31 to be portable^M
***********************************************************************/^M
#define PR_BIT(n)       ((PRUint32)1 << (n))^M
#define PR_BITMASK(n)   (PR_BIT(n) - 1)^M
^M
/***********************************************************************^M
** MACROS:      PR_ROUNDUP^M
**              PR_MIN^M
**                              PR_MAX^M
** DESCRIPTION:^M
**      Commonly used macros for operations on compatible types.^M
***********************************************************************/^M
#define PR_ROUNDUP(x,y) ((((x)+((y)-1))/(y))*(y))^M
#define PR_MIN(x,y)     ((x)<(y)?(x):(y))^M
#define PR_MAX(x,y)     ((x)>(y)?(x):(y))^M
^M
PR_BEGIN_EXTERN_C^M
^M
/************************************************************************^M
** TYPES:       PRUint8^M
**              PRInt8^M
** DESCRIPTION:^M
**  The int8 types are known to be 8 bits each. There is no type that^M
**      is equivalent to a plain "char". ^M
************************************************************************/^M
#if PR_BYTES_PER_BYTE == 1^M
typedef unsigned char PRUint8;^M
/*^M
** Some cfront-based C++ compilers do not like 'signed char' and^M
** issue the warning message:^M
**     warning: "signed" not implemented (ignored)^M
** For these compilers, we have to define PRInt8 as plain 'char'.^M
** Make sure that plain 'char' is indeed signed under these compilers.^M
*/^M
#if (defined(HPUX) && defined(__cplusplus) \^M
        && !defined(__GNUC__) && __cplusplus < 199707L) \^M
    || (defined(SCO) && defined(__cplusplus) \^M
        && !defined(__GNUC__) && __cplusplus == 1L)^M
typedef char PRInt8;^M
#else^M
typedef signed char PRInt8;^M
#endif^M
#else^M
#error No suitable type for PRInt8/PRUint8^M
#endif^M
^M
/************************************************************************^M
** TYPES:       PRUint16^M
**              PRInt16^M
** DESCRIPTION:^M
**  The int16 types are known to be 16 bits each. ^M
************************************************************************/^M
#if PR_BYTES_PER_SHORT == 2^M
typedef unsigned short PRUint16;^M
typedef short PRInt16;^M
#else^M
#error No suitable type for PRInt16/PRUint16^M
#endif^M
^M
/************************************************************************^M
** TYPES:       PRUint32^M
**              PRInt32^M
** DESCRIPTION:^M
**  The int32 types are known to be 32 bits each. ^M
************************************************************************/^M
#if PR_BYTES_PER_INT == 4^M
typedef unsigned int PRUint32;^M
typedef int PRInt32;^M
#define PR_INT32(x)  x^M
#define PR_UINT32(x) x ## U^M
#elif PR_BYTES_PER_LONG == 4^M
typedef unsigned long PRUint32;^M
typedef long PRInt32;^M
#define PR_INT32(x)  x ## L^M
#define PR_UINT32(x) x ## UL^M
#else^M
#error No suitable type for PRInt32/PRUint32^M
#endif^M
^M
/************************************************************************^M
** TYPES:       PRUint64^M
**              PRInt64^M
** DESCRIPTION:^M
**  The int64 types are known to be 64 bits each. Care must be used when^M
**      declaring variables of type PRUint64 or PRInt64. Different hardware^M
**      architectures and even different compilers have varying support for^M
**      64 bit values. The only guaranteed portability requires the use of^M
**      the LL_ macros (see prlong.h).^M
************************************************************************/^M
#ifdef HAVE_LONG_LONG^M
#if PR_BYTES_PER_LONG == 8^M
typedef long PRInt64;^M
typedef unsigned long PRUint64;^M
#elif defined(WIN16)^M
typedef __int64 PRInt64;^M
typedef unsigned __int64 PRUint64;^M
#elif defined(WIN32) && !defined(__GNUC__)^M
typedef __int64  PRInt64;^M
typedef unsigned __int64 PRUint64;^M
#else^M
typedef long long PRInt64;^M
typedef unsigned long long PRUint64;^M
#endif /* PR_BYTES_PER_LONG == 8 */^M
#else  /* !HAVE_LONG_LONG */^M
typedef struct {^M
#ifdef IS_LITTLE_ENDIAN^M
    PRUint32 lo, hi;^M
#else^M
    PRUint32 hi, lo;^M
#endif^M
} PRInt64;^M
typedef PRInt64 PRUint64;^M
#endif /* !HAVE_LONG_LONG */^M
^M
/************************************************************************^M
** TYPES:       PRUintn^M
**              PRIntn^M
** DESCRIPTION:^M
**  The PRIntn types are most appropriate for automatic variables. They are^M
**      guaranteed to be at least 16 bits, though various architectures may^M
**      define them to be wider (e.g., 32 or even 64 bits). These types are^M
**      never valid for fields of a structure. ^M
************************************************************************/^M
#if PR_BYTES_PER_INT >= 2^M
typedef int PRIntn;^M
typedef unsigned int PRUintn;^M
#else^M
#error 'sizeof(int)' not sufficient for platform use^M
#endif^M
^M
/************************************************************************^M
** TYPES:       PRFloat64^M
** DESCRIPTION:^M
**  NSPR's floating point type is always 64 bits. ^M
************************************************************************/^M
typedef double          PRFloat64;^M
^M
/************************************************************************^M
** TYPES:       PRSize^M
** DESCRIPTION:^M
**  A type for representing the size of objects. ^M
************************************************************************/^M
typedef size_t PRSize;^M
^M
^M
/************************************************************************^M
** TYPES:       PROffset32, PROffset64^M
** DESCRIPTION:^M
**  A type for representing byte offsets from some location. ^M
************************************************************************/^M
typedef PRInt32 PROffset32;^M
typedef PRInt64 PROffset64;^M
^M
/************************************************************************^M
** TYPES:       PRPtrDiff^M
** DESCRIPTION:^M
**  A type for pointer difference. Variables of this type are suitable^M
**      for storing a pointer or pointer sutraction. ^M
************************************************************************/^M
typedef ptrdiff_t PRPtrdiff;^M
^M
/************************************************************************^M
** TYPES:       PRUptrdiff^M
** DESCRIPTION:^M
**  A type for pointer difference. Variables of this type are suitable^M
**      for storing a pointer or pointer sutraction. ^M
************************************************************************/^M
typedef unsigned long PRUptrdiff;^M
^M
/************************************************************************^M
** TYPES:       PRBool^M
** DESCRIPTION:^M
**  Use PRBool for variables and parameter types. Use PR_FALSE and PR_TRUE^M
**      for clarity of target type in assignments and actual arguments. Use^M
**      'if (bool)', 'while (!bool)', '(bool) ? x : y' etc., to test booleans^M
**      juast as you would C int-valued conditions. ^M
************************************************************************/^M
typedef PRIntn PRBool;^M
#define PR_TRUE 1^M
#define PR_FALSE 0^M
^M
/************************************************************************^M
** TYPES:       PRPackedBool^M
** DESCRIPTION:^M
**  Use PRPackedBOol within structs where bitfields are not desireable^M
**      but minimum and consistant overhead matters.^M
************************************************************************/^M
typedef PRUint8 PRPackedBool;^M
^M
/*^M
** Status code used by some routines that have a single point of failure or ^M
** special status return.^M
*/^M
typedef enum { PR_FAILURE = -1, PR_SUCCESS = 0 } PRStatus;^M
^M
/*^M
** WARNING: The undocumented data types PRWord and PRUword are^M
** only used in the garbage collection and arena code.  Do not^M
** use PRWord and PRUword in new code.^M
**^M
** A PRWord is an integer that is the same size as a void*.^M
** It implements the notion of a "word" in the Java Virtual^M
** Machine.  (See Sec. 3.4 "Words", The Java Virtual Machine^M
** Specification, Addison-Wesley, September 1996.^M
** http://java.sun.com/docs/books/vmspec/index.html.)^M
*/^M
typedef long PRWord;^M
typedef unsigned long PRUword;^M
^M
#if defined(NO_NSPR_10_SUPPORT)^M
#else^M
/********* ???????????????? FIX ME       ??????????????????????????? *****/^M
/********************** Some old definitions until pr=>ds transition is done ***/^M
/********************** Also, we are still using NSPR 1.0. GC ******************/^M
/*^M
** Fundamental NSPR macros, used nearly everywhere.^M
*/^M
^M
#define PR_PUBLIC_API		PR_IMPLEMENT^M
^M
/*^M
** Macro body brackets so that macros with compound statement definitions^M
** behave syntactically more like functions when called.^M
*/^M
#define NSPR_BEGIN_MACRO        do {^M
#define NSPR_END_MACRO          } while (0)^M
^M
/*^M
** Macro shorthands for conditional C++ extern block delimiters.^M
*/^M
#ifdef NSPR_BEGIN_EXTERN_C^M
#undef NSPR_BEGIN_EXTERN_C^M
#endif^M
#ifdef NSPR_END_EXTERN_C^M
#undef NSPR_END_EXTERN_C^M
#endif^M
^M
#ifdef __cplusplus^M
#define NSPR_BEGIN_EXTERN_C     extern "C" {^M
#define NSPR_END_EXTERN_C       }^M
#else^M
#define NSPR_BEGIN_EXTERN_C^M
#define NSPR_END_EXTERN_C^M
#endif^M
^M
#ifdef XP_MAC^M
#include "protypes.h"^M
#else^M
#include "obsolete/protypes.h"^M
#endif^M
^M
/********* ????????????? End Fix me ?????????????????????????????? *****/^M
#endif /* NO_NSPR_10_SUPPORT */^M
^M
PR_END_EXTERN_C^M
^M
#endif /* prtypes_h___ */^M
^M
