/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */^M
/* ^M
 * The contents of this file are subject to the Mozilla Public^M
 * License Version 1.1 (the "License"); you may not use this file^M
 * except in compliance with the License. You may obtain a copy of^M
 * the License at http://www.mozilla.org/MPL/^M
 * ^M
 * Software distributed under the License is distributed on an "AS^M
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or^M
 * implied. See the License for the specific language governing^M
 * rights and limitations under the License.^M
 * ^M
 * The Original Code is the Netscape Portable Runtime (NSPR).^M
 * ^M
 * The Initial Developer of the Original Code is Netscape^M
 * Communications Corporation.  Portions created by Netscape are ^M
 * Copyright (C) 1998-2000 Netscape Communications Corporation.  All^M
 * Rights Reserved.^M
 * ^M
 * Contributor(s):^M
 * ^M
 * Alternatively, the contents of this file may be used under the^M
 * terms of the GNU General Public License Version 2 or later (the^M
 * "GPL"), in which case the provisions of the GPL are applicable ^M
 * instead of those above.  If you wish to allow use of your ^M
 * version of this file only under the terms of the GPL and not to^M
 * allow others to use your version of this file under the MPL,^M
 * indicate your decision by deleting the provisions above and^M
 * replace them with the notice and other provisions required by^M
 * the GPL.  If you do not delete the provisions above, a recipient^M
 * may use your version of this file under either the MPL or the^M
 * GPL.^M
 */^M
^M
^M
/* author: jstewart */^M
^M
#if defined(_PRVERSION_H)^M
#else^M
#define _PRVERSION_H^M
^M
#include "prtypes.h"^M
^M
PR_BEGIN_EXTERN_C^M
^M
/* All components participating in the PR version protocol must expose^M
 * a structure and a function. The structure is defined below and named^M
 * according to the naming conventions outlined further below.  The function^M
 * is called libVersionPoint and returns a pointer to this structure.^M
 */^M
^M
/* on NT, always pack the structure the same. */^M
#ifdef _WIN32^M
#pragma pack(push, 8)^M
#endif^M
^M
typedef struct {^M
    /*^M
     * The first field defines which version of this structure is in use.^M
     * At this time, only version 2 is specified. If this value is not ^M
     * 2, you must read no further into the structure.^M
     */^M
    PRInt32    version; ^M
  ^M
    /* for Version 2, this is the body format. */^M
    PRInt64         buildTime;      /* 64 bits - usecs since midnight, 1/1/1970 */^M
    char *          buildTimeString;/* a human readable version of the time */^M
  ^M
    PRUint8   vMajor;               /* Major version of this component */^M
    PRUint8   vMinor;               /* Minor version of this component */^M
    PRUint8   vPatch;               /* Patch level of this component */^M
  ^M
    PRBool          beta;           /* true if this is a beta component */^M
    PRBool          debug;          /* true if this is a debug component */^M
    PRBool          special;        /* true if this component is a special build */^M
  ^M
    char *          filename;       /* The original filename */^M
    char *          description;    /* description of this component */^M
    char *          security;       /* level of security in this component */^M
    char *          copyright;      /* The copyright for this file */^M
    char *          comment;        /* free form field for misc usage */^M
    char *          specialString;  /* the special variant for this build */^M
} PRVersionDescription;^M
^M
/* on NT, restore the previous packing */^M
#ifdef _WIN32^M
#pragma pack(pop)^M
#endif^M
^M
/*^M
 * All components must define an entrypoint named libVersionPoint which^M
 * is of type versionEntryPointType.^M
 *^M
 * For example, for a library named libfoo, we would have:^M
 *^M
 *   PRVersionDescription prVersionDescription_libfoo =^M
 *   {^M
 *       ...^M
 *   };^M
 *^M
 *   PR_IMPLEMENT(const PRVersionDescription*) libVersionPoint(void)^M
 *   {^M
 *       return &prVersionDescription_libfoo;^M
 *   }^M
 */^M
typedef const PRVersionDescription *(*versionEntryPointType)(void);^M
^M
/* ^M
 * Where you declare your libVersionPoint, do it like this: ^M
 * PR_IMPLEMENT(const PRVersionDescription *) libVersionPoint(void) {^M
 *  fill it in...^M
 * }^M
 */^M
^M
/*^M
 * NAMING CONVENTION FOR struct^M
 *^M
 * all components should also expose a static PRVersionDescription^M
 * The name of the struct should be calculated as follows:^M
 * Take the value of filename. (If filename is not specified, calculate^M
 * a short, unique string.)  Convert all non-alphanumeric characters^M
 * to '_'.  To this, prepend "PRVersionDescription_".  Thus for libfoo.so,^M
 * the symbol name is "PRVersionDescription_libfoo_so".^M
 * so the file should have^M
 * PRVersionDescription PRVersionDescription_libfoo_so { fill it in };^M
 * on NT, this file should be declspec export.^M
 */^M
^M
PR_END_EXTERN_C^M
^M
#endif  /* defined(_PRVERSION_H) */^M
^M
/* prvrsion.h */^M
^M
